﻿{
function M_CubeDock(thisObj){
// launchPad_buildUI()
// Function for creating the user interface
function mCubeDock_buildUI(thisObj)
{
var pal=  (thisObj instanceof Panel) ? thisObj :new Window('palette', 'MCube',undefined,{resizeable: true});
if (pal!= null) {
	
pal.button =pal.add('button', [5,5,195,35], 'Launch MCube', {name:'Launch MCube'});
pal.button.onClick = function () {MGF_CUBE()};

				
}
return pal;
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



function MGF_CUBE(){ 
//main Function=======================================================================================================
var proj= app.project;
var actComp = proj.activeItem;

if(actComp==null|| !(actComp instanceof CompItem)){alert("Please Select a Composition First")}else{
    
//creating list for dropdown
var myList = new Array(); 
myList.push ("NONE");

for(var i=1; i <=actComp.numLayers; i++){
myList[myList.length]= actComp.layer(i).name;
};



//Building UI
//   Main UI  ---------------------------------------------------------------------------------------------------------------------------------------------
var win = new Window('palette', 'MCube',[300,100,1000,400]);


 win.basepanel = win.add('panel', [10,10,690,290], '');
 win.cubepanel = win.basepanel.add('panel', [10,11,270,141], 'Main Property');
 win.createpanel = win.basepanel.add('panel', [10,151,270,261], '');
 win.width = win.cubepanel.add('Statictext', [8,28,158,53], 'Cube Width');
 win.widthValue = win.cubepanel.add('edittext', [184,28,244,53], '400');
 win.height = win.cubepanel.add('Statictext', [8,58,158,83], 'Cube Height');
 win.heightValue = win.cubepanel.add('edittext', [184,58,244,83], '600');
 win.depth = win.cubepanel.add('Statictext', [8,88,158,113], 'Cube Depth');
 win.depthValue = win.cubepanel.add('edittext', [184,88,244,113], '400');
 win.createbutton = win.createpanel.add('button', [16,14,116,44], 'Create', {name:'Create'});
 
 win.cancelbutton = win.createpanel.add('button', [136,14,236,44], 'Cancel', {name:'Cancel'});
 win.cancelbutton.onClick = function () {this.parent.close(1)};
 win.projectinfo = win.createpanel.add('statictext', [9,53,249,103], '\nMCube V 1.0 | Mographfactory\nCreative Commons Attribution-ShareAlike 4.0',{multiline:true});
 win.radiobuttonpanel = win.basepanel.add('panel', [289,5,669,45], '');
 
 win.radiobutton1 = win.radiobuttonpanel.add('radiobutton', [5,5,185,35], 'Use Single Texture Layer');
 win.radiobutton2 = win.radiobuttonpanel.add('radiobutton', [192,5,372,35], 'Use Separate Texture Layer');
 
//   Single Layer Panel  -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

win.singleLayerPanel = win.basepanel.add('panel', [290,52,670,262], '');
win.singleLayerSecondaryPanel = win.singleLayerPanel.add('panel', [14,10,364,100], 'Single Layer Property');
win.singleLayerText = win.singleLayerSecondaryPanel.add('statictext', [50,21,300,46], 'Choose One Layer');


 var textureLayer = win.singleLayerSecondaryPanel.add('dropdownlist', [50,40,300,63],myList);
 textureLayer.selection=0;
 
 win.projectinfo = win.singleLayerPanel.add('panel', [14,110,364,200], 'Project Info');
 win.statictext = win.projectinfo.add('statictext', [11,7,341,82], '\nSelected Comp:  '+actComp.name+'\nPixel Aspect Ratio:  '+Math.round(actComp.pixelAspect * 100) / 100+'\nComp Resolution:  '+actComp.width+'x'+actComp.height+'\nComp Duration:  ' +parseInt(actComp.duration*actComp.frameRate)+'  Frames' ,{multiline:true});



//   Multi Layer panel -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 win.multilayerpanel = win.basepanel.add('panel', [290,51,670,261], 'Multi Layer Property');
 
 win.statictext = win.multilayerpanel.add('statictext', [14,20,94,45], 'Top Layer');
 win.statictext = win.multilayerpanel.add('statictext', [14,49,94,74], 'Bottom Layer');
 win.statictext = win.multilayerpanel.add('statictext', [14,78,94,103], 'Front Layer');
 win.statictext =win.multilayerpanel.add('statictext', [14,107,94,132], 'Back Layer');
 win.statictext = win.multilayerpanel.add('statictext', [14,136,94,161], 'Left Layer');
 win.statictext = win.multilayerpanel.add('statictext', [14,165,94,190], 'Right Layer');
 
 var mlddTop = win.multilayerpanel.add('dropdownlist', [115,20,365,45], myList);
 mlddTop.selection=0;
 var mlddBottom = win.multilayerpanel.add('dropdownlist', [115,49,365,74],myList);
 mlddBottom.selection=0;
 var mlddFront = win.multilayerpanel.add('dropdownlist', [115,78,365,103], myList);
 mlddFront.selection=0;
 var mlddback = win.multilayerpanel.add('dropdownlist', [115,107,365,132], myList);
 mlddback.selection=0;
 var mlddLeft = win.multilayerpanel.add('dropdownlist', [115,136,365,161], myList);
 mlddLeft.selection=0;
 var mlddRight = win.multilayerpanel.add('dropdownlist', [115,165,365,190], myList);
 mlddRight.selection=0;
//  Radio Button default value  -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
win.radiobutton1.value=true;
win.multilayerpanel.hide();

win.center();
win.show();

//  Panel Hide and Show Function  -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------

win.radiobutton1.onClick=function () {win.multilayerpanel.hide(),win.singleLayerPanel.show()};
win.radiobutton2.onClick=function () {win.singleLayerPanel.hide(),win.multilayerpanel.show()};



//----------------------------------------------------------------------------------------------------------------------------------------------------------------


//button Function
win.cancelbutton.onClick = function () {win.close()};
win.createbutton.onClick = function () {
    if(win.radiobutton1.value){singlelayercube(),win.close()}else{
    if(win.radiobutton2.value){multiLayerCube(),win.close()} 
}  
};



//=======================================================Function For Single Layer Based Cube======================================= 
function singlelayercube(){
    
  app.beginUndoGroup("MCube");  
  
   
    var width= win.widthValue .text*1;
    var height= win.heightValue .text*1;
    var depth=win.depthValue .text*1;
    var par=actComp.pixelAspect;
    var tbDepth=parseInt(depth*par);
    var length= actComp.duration;
    var fr=actComp.frameRate;
   
    var topLayerComp = proj.items.addComp("Cube_Top",width,tbDepth,par,length,fr);
    var bottomLayerComp = proj.items.addComp("Cube_Bottom", width,tbDepth,par,length,fr);
    var leftLayerComp = proj.items.addComp("Cube_Left", depth,height,par,length,fr);
    var rightLayerComp = proj.items.addComp("Cube_Right", depth,height,par,length,fr);
    var frontLayerComp = proj.items.addComp("Cube_Front", width,height,par,length,fr);
    var backLayerComp = proj.items.addComp("Cube_Back", width,height,par,length,fr);
    
    
 //creating texture comp with max size
 var maxValue=Math.max(width,height,depth);
 var textureComp=proj.items.addComp("Cube_Texture",maxValue,maxValue,par,length,fr);
 
 
 //selecting Proper layer from dropdownlist  and copying to  sidelayers
 if(textureLayer.selection.index==0){
     
 var emptyNull=textureComp.layers.addNull();
emptyNull.name="None";
 }else{ 
  

 var layerIndex=textureLayer.selection.index;
 var selectedLayer=actComp.layer(layerIndex);
 
 selectedLayer.copyToComp(textureComp);
 textureComp.layer(1).transform.position.setValue([maxValue/2, maxValue/2]);
 
 };

 // adding texture to side layers
 topLayerComp.layers.add(textureComp);
 bottomLayerComp.layers.add(textureComp);
 leftLayerComp.layers.add(textureComp);
 rightLayerComp.layers.add(textureComp);
 frontLayerComp.layers.add(textureComp);
 backLayerComp.layers.add(textureComp);
 
 //Removing unnecessery layers 
 if(textureLayer.selection.index!=0){
     
     var layerIndex=textureLayer.selection.index;
      var selectedLayer=actComp.layer(layerIndex);
      selectedLayer.remove();
 }
 
 
 
 //organising comps
 var cubeFolder = proj.items.addFolder("Cube");
  topLayerComp.parentFolder = cubeFolder;
  bottomLayerComp.parentFolder = cubeFolder;
  leftLayerComp.parentFolder = cubeFolder;
  rightLayerComp.parentFolder = cubeFolder;
  frontLayerComp.parentFolder = cubeFolder;
  backLayerComp.parentFolder = cubeFolder;
  textureComp.parentFolder = cubeFolder;

 
 
//adding sidelayers to maincomp
var topLayer= actComp.layers.add(topLayerComp);
topLayer.threeDLayer=true;
var bottomLayer= actComp.layers.add(bottomLayerComp);
bottomLayer.threeDLayer=true;
var leftLayer= actComp.layers.add(leftLayerComp);
leftLayer.threeDLayer=true;
var rightLayer= actComp.layers.add(rightLayerComp);
rightLayer.threeDLayer=true;
var frontLayer= actComp.layers.add(frontLayerComp);
 frontLayer.threeDLayer=true;
var backLayer= actComp.layers.add(backLayerComp);
backLayer.threeDLayer=true;


//creating Control Null
var controlNull=actComp.layers.addNull();
controlNull.name = "Cube Control";
controlNull.threeDLayer = true;


//creating cube
leftLayer.property("Transform").property("Y Rotation").setValue(90);
rightLayer.property("Transform").property("Y Rotation").setValue(-90);
topLayer.property("Transform").property("X Rotation").setValue(-90);
bottomLayer.property("Transform").property("X Rotation").setValue(90);
backLayer.property("Transform").property("Y Rotation").setValue(180);

leftLayer.property("Transform").property("Position").setValue([(actComp.width/2)-(width/2),(actComp.height/2),(depth/2)*par]);
backLayer.property("Transform").property("Position").setValue([(actComp.width/2),(actComp.height/2),depth*par]);
rightLayer.property("Transform").property("Position").setValue([(actComp.width/2)+(width/2),(actComp.height/2),(depth/2)*par]);
topLayer.property("Transform").property("Position").setValue([(actComp.width/2),(actComp.height/2)-(height/2),tbDepth/2]);
bottomLayer.property("Transform").property("Position").setValue([(actComp.width/2),(actComp.height/2)+(height/2),tbDepth/2]);


//parenting cube with null
leftLayer.parent = controlNull;
rightLayer.parent = controlNull;
topLayer.parent = controlNull;
bottomLayer.parent = controlNull;
frontLayer.parent = controlNull;
backLayer.parent = controlNull;

app.endUndoGroup();
};




//=======================================================Function For Multiple Layer Based Cube======================================= 

function multiLayerCube(){
    
app.beginUndoGroup("MCube"); 


    var width= win.widthValue .text*1;
    var height= win.heightValue .text*1;
    var depth=win.depthValue .text*1;
    var par=actComp.pixelAspect;
    var tbDepth=parseInt(depth*par);
    var length= actComp.duration;
    var fr=actComp.frameRate;
    
    
 //creating comps for side layers  
    var topLayerComp = proj.items.addComp("Cube_Top",width,tbDepth,par,length,fr);
    var bottomLayerComp = proj.items.addComp("Cube_Bottom", width,tbDepth,par,length,fr);
    var leftLayerComp = proj.items.addComp("Cube_Left", depth,height,par,length,fr);
    var rightLayerComp = proj.items.addComp("Cube_Right", depth,height,par,length,fr);
    var frontLayerComp = proj.items.addComp("Cube_Front", width,height,par,length,fr);
    var backLayerComp = proj.items.addComp("Cube_Back", width,height,par,length,fr);
    

//selecting layer and adding to comps for sides

//for top layer
var topIndex=mlddTop.selection.index;
if(topIndex==0){
    var noneNull=topLayerComp.layers.addNull();
    noneNull.name="NONE";
}else{
    var mainTopLayer=actComp.layer(topIndex);
    mainTopLayer.copyToComp(topLayerComp);
    topLayerComp.layer(1).transform.position.setValue([topLayerComp.width/2,topLayerComp.height/2]);
};

//for bottom layer
var bottomIndex=mlddBottom.selection.index;
if(bottomIndex==0){
     var noneNull=bottomLayerComp.layers.addNull();
     noneNull.name="NONE";
}else{
    var mainBottomLayer=actComp.layer(bottomIndex);
    mainBottomLayer.copyToComp(bottomLayerComp);
    bottomLayerComp.layer(1).transform.position.setValue([bottomLayerComp.width/2,bottomLayerComp.height/2]);
};


//for left layer
var leftIndex=mlddLeft.selection.index;
if(leftIndex==0){
    var noneNull=leftLayerComp.layers.addNull();
    noneNull.name="NONE";
}else{
    var mainLeftLayer=actComp.layer(leftIndex);
    mainLeftLayer.copyToComp(leftLayerComp);
    leftLayerComp.layer(1).transform.position.setValue([leftLayerComp.width/2,leftLayerComp.height/2]);
};


//for right layer
var rightIndex=mlddRight.selection.index;
if(rightIndex==0){
    var noneNull=rightLayerComp.layers.addNull();
    noneNull.name="NONE";
}else{
    var mainRightLayer=actComp.layer(rightIndex);
    mainRightLayer.copyToComp(rightLayerComp);
    rightLayerComp.layer(1).transform.position.setValue([rightLayerComp.width/2,rightLayerComp.height/2]);
};

//for front layer
var frontIndex=mlddFront.selection.index;
if(frontIndex==0){
    var noneNull=frontLayerComp.layers.addNull();
    noneNull.name="NONE";
 }else{
    var mainFrontLayer=actComp.layer(frontIndex);
    mainFrontLayer.copyToComp(frontLayerComp);
    frontLayerComp.layer(1).transform.position.setValue([frontLayerComp.width/2,frontLayerComp.height/2]);
};

//for back layer
var backIndex=mlddback.selection.index;
if(backIndex==0){
    var noneNull=backLayerComp.layers.addNull();
    noneNull.name="NONE";
}else{
    var mainBackLayer=actComp.layer(backIndex);
    mainBackLayer.copyToComp(backLayerComp);
    backLayerComp.layer(1).transform.position.setValue([backLayerComp.width/2,backLayerComp.height/2]);
};

//adding sidelayers to maincomp
var topLayer= actComp.layers.add(topLayerComp);
topLayer.threeDLayer=true;
var bottomLayer= actComp.layers.add(bottomLayerComp);
bottomLayer.threeDLayer=true;
var leftLayer= actComp.layers.add(leftLayerComp);
leftLayer.threeDLayer=true;
var rightLayer= actComp.layers.add(rightLayerComp);
rightLayer.threeDLayer=true;
var frontLayer= actComp.layers.add(frontLayerComp);
 frontLayer.threeDLayer=true;
var backLayer= actComp.layers.add(backLayerComp);
backLayer.threeDLayer=true;


//creating Control Null
var controlNull=actComp.layers.addNull();
controlNull.name = "Cube Control";
controlNull.threeDLayer = true;


//creating cube
leftLayer.property("Transform").property("Y Rotation").setValue(90);
rightLayer.property("Transform").property("Y Rotation").setValue(-90);
topLayer.property("Transform").property("X Rotation").setValue(-90);
bottomLayer.property("Transform").property("X Rotation").setValue(90);
backLayer.property("Transform").property("Y Rotation").setValue(180);

leftLayer.property("Transform").property("Position").setValue([(actComp.width/2)-(width/2),(actComp.height/2),(depth/2)*par]);
backLayer.property("Transform").property("Position").setValue([(actComp.width/2),(actComp.height/2),depth*par]);
rightLayer.property("Transform").property("Position").setValue([(actComp.width/2)+(width/2),(actComp.height/2),(depth/2)*par]);
topLayer.property("Transform").property("Position").setValue([(actComp.width/2),(actComp.height/2)-(height/2),tbDepth/2]);
bottomLayer.property("Transform").property("Position").setValue([(actComp.width/2),(actComp.height/2)+(height/2),tbDepth/2]);


//parenting cube with null
leftLayer.parent = controlNull;
rightLayer.parent = controlNull;
topLayer.parent = controlNull;
bottomLayer.parent = controlNull;
frontLayer.parent = controlNull;
backLayer.parent = controlNull;


//organising comps
 var cubeFolder = proj.items.addFolder("Cube");
  topLayerComp.parentFolder = cubeFolder;
  bottomLayerComp.parentFolder = cubeFolder;
  leftLayerComp.parentFolder = cubeFolder;
  rightLayerComp.parentFolder = cubeFolder;
  frontLayerComp.parentFolder = cubeFolder;
  backLayerComp.parentFolder = cubeFolder;
  
  
//removing unnecessery layers
for(var i=1; i <=actComp.numLayers; i++){
if(actComp.layer(i)==mainTopLayer){actComp.layer(i).remove()}
};
for(var i=1; i <=actComp.numLayers; i++){
if(actComp.layer(i)==mainBottomLayer){actComp.layer(i).remove()}
};
for(var i=1; i <=actComp.numLayers; i++){
if(actComp.layer(i)==mainLeftLayer){actComp.layer(i).remove()}
};
for(var i=1; i <=actComp.numLayers; i++){
if(actComp.layer(i)==mainRightLayer){actComp.layer(i).remove()}
};
for(var i=1; i <=actComp.numLayers; i++){
if(actComp.layer(i)==mainFrontLayer){actComp.layer(i).remove()}
};
for(var i=1; i <=actComp.numLayers; i++){
if(actComp.layer(i)==mainBackLayer){actComp.layer(i).remove()}
};



app.endUndoGroup();
};
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
}
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
// Build and show the UI
var mCubeDockPal = mCubeDock_buildUI(thisObj);
if (mCubeDockPal  != null){
if (mCubeDockPal  instanceof Window){
// Center the palette
mCubeDockPal .center();
// Show the UI
mCubeDockPal.show();
}
}
}
}
M_CubeDock(this);
